import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Category, CategoryParam } from './model';
import { OPEN_API_URL } from '@/config/setting';
// const merchantCode = String(localStorage.getItem('MerchantCode'));

/**
 * 分页查询商品分类
 */
export async function pageCategory(params: CategoryParam) {
  const res = await request.get<ApiResult<PageResult<Category>>>(
    OPEN_API_URL + '/shop/category/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品分类列表
 */
export async function listCategory(params?: CategoryParam) {
  const res = await request.get<ApiResult<Category[]>>(
    OPEN_API_URL + '/shop/category',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品分类
 */
export async function addCategory(data: Category) {
  const res = await request.post<ApiResult<unknown>>(
    OPEN_API_URL + '/shop/category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品分类
 */
export async function updateCategory(data: Category) {
  const res = await request.put<ApiResult<unknown>>(
    OPEN_API_URL + '/shop/category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品分类
 */
export async function removeCategory(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    OPEN_API_URL + '/shop/category/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品分类
 */
export async function removeBatchCategory(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    OPEN_API_URL + '/shop/category/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    OPEN_API_URL + '/shop/category/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
